/* copyright (c) 2007 magnus auvinen, see licence.txt for more info */
#ifndef GAME_MAPRES_COL_H
#define GAME_MAPRES_COL_H

#include <base/vmath.hpp>

enum
{
	COLFLAG_SOLID=1,
	COLFLAG_DEATH=2,
	COLFLAG_NOHOOK=4,
	COLFLAG_HEALING=8,
	COLFLAG_POISON=16,
	COLFLAG_DOOR=32
};

int col_init();
int col_is_solid(int x, int y);
int col_get(int x, int y);
int col_width();
int col_height();
int col_intersect_line(vec2 pos0, vec2 pos1, vec2 *out_collision, vec2 *out_before_collision, bool check_doors);
vec2 col_teleport(int x, int y);
void col_set_door(int start_x, int start_y, int end_x, int end_y);
int col_is_door(int x, int y);

#endif
