/* copyright (c) 2007 magnus auvinen, see licence.txt for more info */
#include <game/server/gamecontext.hpp>
#include <game/server/gamemodes/exp/exp.hpp>

#include "flag.hpp"


FLAG::FLAG(int _team)
: ENTITY(NETOBJTYPE_FLAG)
{
	team = _team;
	proximity_radius = phys_size;
	carrying_character = 0x0;
	grab_tick = 0;
	
	reset();
	
	// TODO: should this be done here?
	game.world.insert_entity(this);
}

void FLAG::reset()
{
	carrying_character = 0x0;
	at_stand = 1;
	pos = stand_pos;
	vel = vec2(0,0);
	grab_tick = 0;
}

void FLAG::snap(int snapping_client)
{
	if(game.controller->isEXP())
	{
		if(team == 0)
		{
			if(networkclipped(snapping_client))
				return;
		}
		else
		{
			if(((GAMECONTROLLER_EXP *)game.controller)->boss.exist && !game.players[snapping_client]->game_exp.boss_killer)
				return;
		}
	}
	
	NETOBJ_FLAG *flag = (NETOBJ_FLAG *)snap_new_item(NETOBJTYPE_FLAG, id, sizeof(NETOBJ_FLAG));
	flag->x = (int)pos.x;
	flag->y = (int)pos.y;
	flag->team = team;
	flag->carried_by = -1;
	
	if(at_stand)
		flag->carried_by = -2;
	else if(carrying_character && carrying_character->player)
		flag->carried_by = carrying_character->player->client_id;
}
