/* copyright (c) 2007 magnus auvinen, see licence.txt for more info */

#ifndef GAME_SERVER_ENTITY_PICKUP_H
#define GAME_SERVER_ENTITY_PICKUP_H

#include <game/server/entity.hpp>

class PICKUP : public ENTITY
{
public:
	static const int phys_size = 14;
	
	int type;
	int subtype; //weapon type
	int spawntick;
	PICKUP(int _type, int _subtype = 0);
	
	virtual void reset();
	virtual void tick();
	virtual void snap(int snapping_client);
	
	
	//EXPlorer :
	
	bool from_drop;
	float animation_timer;
	float die_timer;
	bool is_boss_shield;
	
	const char * get_weapon_name(int wid);
	int real_pickup(int type);
	int real_weapon(int wid);
	void create_random_from_bot(int lvl);
	void create_random_from_turret(int turret_type);
	void make_boss_shield();
};

#endif
