#include <string.h>

#include <game/server/gamecontext.hpp>
#include "exp.hpp"
#include "treasures.hpp"



void GAMECONTROLLER_EXP::send_items(int client_id)
{
	NETMSG_SV_VOTE_CLEAROPTIONS clearmsg;
	clearmsg.pack(MSGFLAG_VITAL);
	server_send_msg(client_id);
	
	NETMSG_SV_VOTE_OPTION optionmsg;
	optionmsg.command = "        ITEM             COPIES";
	optionmsg.pack(MSGFLAG_VITAL);
	server_send_msg(client_id);
	optionmsg.command = "";
	optionmsg.pack(MSGFLAG_VITAL);
	server_send_msg(client_id);
	
	for(int i = 0; i < NUM_ITEMS; i++)
		send_item(client_id, i);
	
	optionmsg.command = "";
	optionmsg.pack(MSGFLAG_VITAL);
	server_send_msg(client_id);
	
	VOTEOPTION * current = first_option;
	while(current)
	{
		NETMSG_SV_VOTE_OPTION optionmsg;
		optionmsg.command = current->command;
		optionmsg.pack(MSGFLAG_VITAL);
		server_send_msg(client_id);
		current = current->next;
	}
}



void GAMECONTROLLER_EXP::send_item(int client_id, int item)
{
	char buf[256];
	ITEMS * items = &game.players[client_id]->game_exp.items;
	if(item == ITEM_LIFE)
		str_format(buf, sizeof(buf), "         Life                      %d", items->lives);
	else if(item == ITEM_MINOR_POTION)
		str_format(buf, sizeof(buf), "  Minor Potion             %d", items->minor_potions);
	else if(item == ITEM_GREATER_POTION)
		str_format(buf, sizeof(buf), "Greater Potion            %d", items->greater_potions);
	else
		return;
	
	NETMSG_SV_VOTE_OPTION optionmsg;
	optionmsg.command = buf;
	optionmsg.pack(MSGFLAG_VITAL);
	server_send_msg(client_id);
}





bool GAMECONTROLLER_EXP::use(int client_id, const char * command)
{
	if(strcmp(command, "        ITEM             COPIES") == 0 || strcmp(command, "") == 0)
		return true;
	
	PLAYER * p = game.players[client_id];
	
	if(str_find_nocase(command, "Life"))
	{
		if(p->game_exp.items.lives > 0)
		{
			if(p->team != -1 && !p->get_character())
			{
				p->game_exp.items.lives--;
				p->load_game(p->view_pos, p->game_exp.last_flag, p->score, p->game_exp.time, p->game_exp.armor_max, p->game_exp.weapons, p->game_exp.items, p->game_exp.boss_hitter, p->game_exp.boss_killer);
				send_items(client_id);
				char buf[256];
				str_format(buf, sizeof(buf), "Life used. You have now %d Lives.", p->game_exp.items.lives);
				game.send_chat_target(client_id, buf);
			}
			else
				game.send_chat_target(client_id, "You are not dead !");
		}
		else
			game.send_chat_target(client_id, "You haven't Life !");
		return true;
	}

	else if(str_find_nocase(command, "Minor Potion"))
	{
		if(p->get_character())
		{
			if(p->game_exp.items.minor_potions > 0)
			{
				if(p->get_character()->health < 10)
				{
					p->game_exp.items.minor_potions--;
					p->get_character()->health = 10;
					send_items(client_id);
					char buf[256];
					str_format(buf, sizeof(buf), "Minor Potion used. You have now %d Minor Potions.", p->game_exp.items.minor_potions);
					game.send_chat_target(client_id, buf);
				}
				else
					game.send_chat_target(client_id, "You don't need to use it now !");
			}
			else
				game.send_chat_target(client_id, "You haven't Minor Potion !");
		}
		return true;
	}

	else if(str_find_nocase(command, "Greater Potion"))
	{
		if(p->get_character())
		{
			if(p->game_exp.items.greater_potions > 0)
			{
				if(p->get_character()->health < 10 || p->get_character()->armor < p->game_exp.armor_max)
				{
					p->game_exp.items.greater_potions--;
					p->get_character()->health = 10;
					p->get_character()->armor = p->game_exp.armor_max;
					send_items(client_id);
					char buf[256];
					str_format(buf, sizeof(buf), "Greater Potion used. You have now %d Greater Potions.", p->game_exp.items.greater_potions);
					game.send_chat_target(client_id, buf);
				}
				else
					game.send_chat_target(client_id, "You don't need to use it now !");
			}
			else
				game.send_chat_target(client_id, "You haven't Greater Potion !");
		}
		return true;
	}
	
	return false;
}
